package cd.casic.ci.commons.bean.engine.job;


import cd.casic.ci.commons.bean.support.deploy.TaskDeployInstance;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

import java.util.List;


/**
 * @author by mianbin
 * @Classname Test
 * @Description 任务实例模型
 * @Date 2025/4/22 8:45
 */
@Data
@Builder
@Accessors(chain = true)
@NoArgsConstructor
@AllArgsConstructor
public class TaskInstance {

    //日志id
    private String id;

    //历史Id
    private String instanceId;

    //运行类型
    private String taskType;

    //执行顺序
    private int jobSort;

    //任务名称
    private String taskName;

    //运行日志地址
    private String logAddress;

    //运行时间
    private int runTime;

    //运行时间
    private String runTimeDate;

    //运行状态 error.失败 success.成功 halt.停止 wait.等待，后面设置成枚举
    private String runState;

    //阶段id
    private String stagesId;

    //后置任务id
    private String postprocessId;

    //运行日志
    private String runLog;

    // 部署实例日志
    private List<TaskDeployInstance> deployInstanceList;
    // 执行顺序
    private int taskSort ;
}
