package cd.casic.ci.commons.bean.support.deploy;


import cd.casic.ci.commons.bean.process.setting.HostGroup;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * 任务部署模型
 *
 * @author mianbin
 */
@Data
@Builder
@Accessors(chain = true)
@NoArgsConstructor
@AllArgsConstructor
public class TaskDeploy {

    //id
    private String taskId;

    //部署方式，自定义部署，结构化部署
    private int authType;

    //文件地址
    private String localAddress;

    //部署地址
    private String deployAddress;

    //认证id
    private String authId;

    //部署命令
    private String deployOrder;

    //启动文件地址
    private String startAddress;

    //启动命令
    private String startOrder;

    //规则
    private String rule;

    //规则
    private String dockerImage;

    // 主机类型 host--主机  hostGroup--主机组
    private String hostType;

    //授权信息
    private Object auth;

    private int sort;

    private String type;

    // 命名空间
    private String k8sNamespace;

    // 配置文件
    private String k8sJson;

    // 策略类型
    private String strategyType;

    // 策略数量
    private Integer strategyNumber;

    private String instanceId;

    private List<HostGroup> hostGroupList;
}
