package cd.casic.module.machine.contants;

import cd.casic.framework.commons.exception.ErrorCode;

/**
 * 机器报错
 */
public interface MachineErrorCodeConstants {
    // ========== 机器模块 1-003-000-000 ==========
    ErrorCode MACHINE_INFO_NULL = new ErrorCode(1_003_000_000, "机器信息为空");
    ErrorCode UPLOADING_FILE_FAIL = new ErrorCode(1_003_000_001, "上传文件失败");
    ErrorCode DOWNLOAD_FILE_FAIL = new ErrorCode(1_003_000_002, "下载失败");
    ErrorCode FILENAME_NULL = new ErrorCode(1_003_000_003, "文件名为空");
    ErrorCode READ_FILE_FAIL = new ErrorCode(1_003_000_004, "读取文件失败");
    ErrorCode DELETE_FILE_FAIL = new ErrorCode(1_003_000_005, "删除文件失败");

    ErrorCode PARAMETER_ERROR = new ErrorCode(1_003_000_008, "参数错误");
    //  ========== 机器环境变量模块 1-003-000-009 ==========
    ErrorCode MACHINE_ENV_NULL = new ErrorCode(1_003_000_009, "机器环境变量为空");
    ErrorCode MACHINE_ENV_NOT_EXISTS = new ErrorCode(1_003_000_009, "机器不存在");
    ErrorCode MACHINE_ENV_KEY_ILLEGAL = new ErrorCode(1_003_000_010, "机器环境变量键不合法");
    //  ========== 机器代理模块 1-003-000-006 ==========
    ErrorCode MACHINE_PROXY_HOST_IP_NULL = new ErrorCode(1_003_000_006, "机器代理主机地址为空");
    ErrorCode MACHINE_PROXY_USER_NAME_NULL = new ErrorCode(1_003_000_006, "机器代理用户名为空");
    ErrorCode MACHINE_PROXY_NOT_EXISTS = new ErrorCode(1_003_000_007, "机器代理不存在");
    ErrorCode MACHINE_PROXY_TYPE_NOT_EXISTS = new ErrorCode(1_003_000_007, "机器代理类型不存在");
    ErrorCode MACHINE_PROXY_IS_ONLINE = new ErrorCode(1_003_000_007, "机器代理在线，不能删除");

    ErrorCode OSS_PARAM_NULL = new ErrorCode(1_003_000_011, "oss参数无法读取");
    ErrorCode SECRETKEY_NULL = new ErrorCode(1_003_000_012, "密钥为空");
}


