//package cd.casic.module.machine.controller;
//
//import cd.casic.framework.commons.pojo.CommonResult;
//import cd.casic.framework.commons.pojo.PageResult;
//import cd.casic.module.machine.dal.dataobject.MachineInfo;
//import cd.casic.module.machine.enums.ConnectionStatus;
//import cd.casic.module.machine.service.MachineInfoService;
//import cd.casic.module.machine.controller.vo.MachineInfoDto;
//import io.swagger.v3.oas.annotations.Operation;
//import io.swagger.v3.oas.annotations.tags.Tag;
//import jakarta.annotation.Resource;
//import org.springframework.web.bind.annotation.*;
//
//import java.util.Map;
//
//import static cd.casic.framework.commons.pojo.CommonResult.success;
//
//@RestController
//@Tag(name = "机器信息管理")
//@RequestMapping("/api/machineInfo")
//public class MachineInfoController {
//    @Resource
//    private MachineInfoService machineInfoService;
//
//    @PostMapping("/add")
//    @Operation(summary = "新增机器信息")
//    public CommonResult<Boolean> add(@RequestBody MachineInfoDto machineInfoDto) {
//        return success(machineInfoService.addMachineInfo(machineInfoDto));
//    }
//
//
//    @PostMapping("/list")
//    @Operation(summary = "获取机器信息列表")
//    public CommonResult<PageResult<MachineInfoDto>> list(@RequestBody MachineInfoDto machineInfoDto) {
//        return success(machineInfoService.listMachineInfo(machineInfoDto));
//    }
//
//    @PutMapping("/update")
//    @Operation(summary = "编辑机器信息")
//    public CommonResult<Boolean> update(@RequestBody MachineInfoDto machineInfoDto) {
//        return success(machineInfoService.updateMachineInfo(machineInfoDto));
//    }
//
//    @PutMapping("/updateStatus")
//    @Operation(summary = "机器启用/停用")
//    public CommonResult<Boolean> updateStatus(@RequestBody MachineInfoDto machineInfoDto) {
//        return success(machineInfoService.updateStatus(machineInfoDto));
//    }
//
//    @PutMapping("/bindingSecretKey")
//    @Operation(summary = "绑定密钥")
//    public CommonResult<Boolean> bindingSecretKey(@RequestBody MachineInfoDto machineInfoDto) {
//        return success(machineInfoService.bindingSecretKey(machineInfoDto));
//    }
//
//    @DeleteMapping("/delete")
//    @Operation(summary = "机器信息删除")
//    public CommonResult<Boolean> delete(@RequestParam Long machineInfoId) {
//        machineInfoService.deleteMachineInfo(machineInfoId);
//        return success(true);
//    }
//
//    @DeleteMapping("/deleteList")
//    @Operation(summary = "批量删除机器信息")
//    public CommonResult<Boolean> deleteList(@RequestParam String machineInfoIds) {
//        machineInfoService.deleteList(machineInfoIds);
//        return success(true);
//    }
//
//    @PostMapping("/test")
//    @Operation(summary = "测试机器连接")
//    public CommonResult<Boolean> testConnection(@RequestParam Long id) {
//        return success(machineInfoService.testConnection(id));
//    }
//
//    @GetMapping("/status/{machineName}")
//    @Operation(summary = "获取机器连接状态")
//    public CommonResult<ConnectionStatus> getConnectionStatus(@PathVariable String machineName) {
//        return success(machineInfoService.getConnectionStatus(machineName));
//    }
//
//    @GetMapping("/status/all")
//    @Operation(summary = "获取所有机器连接状态")
//    public CommonResult<Map<String, ConnectionStatus>> getAllConnectionStatus() {
//        return success(machineInfoService.getAllConnectionStatus());
//    }
//
//    @PostMapping("/connect")
//    @Operation(summary = "建立机器连接")
//    public CommonResult<String> connect(@RequestBody MachineInfo machineInfo) {
//        return success(machineInfoService.connect(machineInfo));
//    }
//
//    @PostMapping("/disconnect/{sessionId}")
//    @Operation(summary = "断开机器连接")
//    public CommonResult<Boolean> disconnect(@PathVariable String sessionId) {
//        return success(machineInfoService.disconnect(sessionId));
//    }
//
//    @PostMapping("/execute/{sessionId}")
//    @Operation(summary = "执行远程命令")
//    public CommonResult<String> executeCommand(
//        @PathVariable String sessionId,
//        @RequestBody String command) {
//
//        return success(machineInfoService.executeCommand(sessionId, command));
//    }
//
//    @PostMapping("/upload/{sessionId}")
//    @Operation(summary = "上传文件到远程机器")
//    public CommonResult<Boolean> uploadFile(
//        @PathVariable String sessionId,
//        @RequestParam String localFilePath,
//        @RequestParam String remoteFilePath) {
//        return success(machineInfoService.uploadFile(sessionId, localFilePath, remoteFilePath));
//    }
//
//    @PostMapping("/download/{sessionId}")
//    @Operation(summary = "从远程机器下载文件")
//    public CommonResult<Boolean> downloadFile(
//        @PathVariable String sessionId,
//        @RequestParam String remoteFilePath,
//        @RequestParam String localFilePath) {
//        return success(machineInfoService.downloadFile(sessionId, remoteFilePath, localFilePath));
//    }
//}
