package cd.casic.module.machine.dal.dataobject;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import cd.casic.module.machine.enums.AuthenticationType;
import cd.casic.module.machine.enums.MachineInfoStatus;
import cd.casic.module.machine.enums.MachineInfoType;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@EqualsAndHashCode(callSuper = true)
@Data
@AllArgsConstructor
@NoArgsConstructor
@TableName(value = "machine_info")
public class MachineInfo extends BaseEntity {
    @TableField(value = "name")
    private String name;

    @TableField(value = "tag")
    private String tag;

    @TableField(value = "host_ip")
    private String hostIp;

    @TableField(value = "description")
    private String description;

    @TableField(exist = false)
    private MachineInfoType machineInfoType;

    @TableField(value = "machine_info_type_code")
    private int machineInfoTypeCode;


    @TableField(exist = false)
    private MachineInfoStatus status;

    @TableField(value = "status_code")
    private int statusCode;

    //用户名
    @TableField(value = "username")
    private String username;

    //SSH端口号
    @TableField(value = "ssh_port")
    private Integer sshPort;

    @TableField(value = "password")
    private String password;

    @TableField(value = "secret_key_id")
    private Long secretKeyId;

    @TableField(value = "machine_proxy_id")
    private Long machineProxyId;

    @TableField(value = "authentication_type_code")
    private int authenticationTypeCode;

    @TableField(exist = false)
    private AuthenticationType authenticationType;

    @TableField(value = "is_proxy")
    private int isProxy;
}
