//package cd.casic.module.machine.service.impl;
//import cd.casic.module.machine.enums.MachineInfoType;
//import cd.casic.module.machine.handler.ConnectionSession;
//import cd.casic.module.machine.dal.mysql.MachineInfoMapper;
//import cd.casic.module.machine.controller.vo.MachineInfoDto;
//import cd.casic.module.machine.dal.dataobject.MachineInfo;
//import cd.casic.module.machine.enums.AuthenticationType;
//import cd.casic.module.machine.enums.ConnectionStatus;
//import cd.casic.module.machine.enums.MachineInfoStatus;
//import cd.casic.module.machine.service.MachineInfoService;
//import cd.casic.module.machine.utils.EnumUtils;
//import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
//import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
//import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
//import jakarta.annotation.Resource;
//import lombok.extern.slf4j.Slf4j;
//import org.springframework.beans.BeanUtils;
//import org.springframework.stereotype.Service;
//import java.util.Arrays;
//import java.util.HashMap;
//import java.util.List;
//import java.util.Map;
//import java.util.concurrent.ConcurrentHashMap;
//import java.util.concurrent.atomic.AtomicInteger;
//import java.util.stream.Collectors;
//
//@Slf4j
//@Service("machineInfoService")
//public class MachineinfoServiceImpl  implements MachineInfoService {
//
//    int ENABLE = 1;
//    int UN_ENABLE = 0;
//
//    @Resource
//    private MachineInfoMapper machineInfoMapper;
//    @Resource
//    private ConnectionSession connectionSession;
//    /**
//     * 会话ID生成器
//     */
//    private final AtomicInteger sessionIdGenerator = new AtomicInteger(1000);
//
//    /**
//     * 会话管理：会话ID -> 连接会话
//     */
//    private final Map<String, ConnectionSession> sessions = new ConcurrentHashMap<>();
//
//    /**
//     * 机器名称 -> 会话ID
//     */
//    private final Map<String, String> machineSessionMapping = new ConcurrentHashMap<>();
//
//    @Override
//    public boolean addMachineInfo(MachineInfoDto machineInfoDto) {
//        if (machineInfoDto == null) {
//            throw new ServiceException(ServiceException.MACHINE_INFO_NULL, "机器信息为空");
//        }
//        MachineInfo machineInfo = new MachineInfo();
//        BeanUtils.copyProperties(machineInfoDto, machineInfo);
//        machineInfo.setStatusCode(1);
//        machineInfo.setAuthenticationTypeCode(
//            "密码认证".equals(machineInfoDto.getAuthenticationType())
//                ? AuthenticationType.PASSWORD.getCode()
//                : AuthenticationType.SECRET_KEY.getCode()
//        );
//        machineInfo.setMachineInfoTypeCode(
//            "Windows".equals(machineInfoDto.getMachineInfoType())
//                ? MachineInfoType.WINDOWS.getCode()
//                : MachineInfoType.Linux.getCode()
//        );
//
//        return this.save(machineInfo);
//    }
//
//    @Override
//    public PageResult<MachineInfoDto> listMachineInfo(MachineInfoDto machineInfoDto) {
//        QueryWrapper<MachineInfo> queryWrapper = getMachineInfoQueryWrapper(machineInfoDto);
//        Page<MachineInfo> page = machineInfoMapper.selectPage(
//            new Page<>(machineInfoDto.getPageIndex(), machineInfoDto.getPageSize()),
//            queryWrapper
//        );
//
//        List<MachineInfoDto> machineInfoDtos = page.getRecords().stream()
//            .map(machineInfo -> {
//                MachineInfoDto dto = new MachineInfoDto();
//                BeanUtils.copyProperties(machineInfo, dto);
//                // 直接调用原有枚举转换方法
//                dto.setMachineInfoType(EnumUtils.getEnumByCode(machineInfo.getMachineInfoTypeCode(), MachineInfoType.class).getMessage());
//                dto.setStatus(EnumUtils.getEnumByCode(machineInfo.getStatusCode(), MachineInfoStatus.class).getMessage());
//                dto.setAuthenticationType(EnumUtils.getEnumByCode(machineInfo.getAuthenticationTypeCode(), AuthenticationType.class).getMessage());
//                return dto;
//            })
//            .toList();
//
//        return new PageResult<>(
//            page.getCurrent(),
//            page.getSize(),
//            page.getTotal(),
//            page.getPages(),
//            machineInfoDtos
//        );
//    }
//
//    @Override
//    public boolean updateMachineInfo(MachineInfoDto machineInfoDto) {
//        MachineInfo machineInfo = new MachineInfo();
//        BeanUtils.copyProperties(machineInfoDto, machineInfo);
//        machineInfo.setAuthenticationTypeCode(
//            "密码认证".equals(machineInfoDto.getAuthenticationType())
//                ? AuthenticationType.PASSWORD.getCode()
//                : AuthenticationType.SECRET_KEY.getCode()
//        );
//        machineInfo.setMachineInfoTypeCode(
//            "Windows".equals(machineInfoDto.getMachineInfoType())
//                ? MachineInfoType.WINDOWS.getCode()
//                : MachineInfoType.Linux.getCode()
//        );
//        return this.updateById(machineInfo);
//    }
//
//    @Override
//    public boolean updateStatus(MachineInfoDto machineInfoDto) {
//        UpdateWrapper<MachineInfo> updateWrapper = new UpdateWrapper<>();
//        updateWrapper.eq("id", machineInfoDto.getId()).set("status_code", EnumUtils.getEnumByMessage(machineInfoDto.getStatus(), MachineInfoStatus.class).getCode());
//        return this.update(updateWrapper);
//    }
//
//    @Override
//    public boolean bindingSecretKey(MachineInfoDto machineInfoDto) {
//        UpdateWrapper<MachineInfo> updateWrapper = new UpdateWrapper<>();
//        updateWrapper.eq("id", machineInfoDto.getId()).set("secret_key_id", machineInfoDto.getSecretKeyId()).set("authentication_type_code", 2);
//        return this.update(updateWrapper);
//    }
//
//    @Override
//    public void deleteList(String machineInfoIds) {
//        List<Long> machineInfoIdList = Arrays.stream(machineInfoIds.split(","))
//            .map(String::trim)
//            .filter(s -> !s.isEmpty())
//            .map(Long::parseLong)
//            .collect(Collectors.toList());
//        machineInfoMapper.selectBatchIds(machineInfoIdList).forEach(machineInfo -> {
//            if (machineInfo.getStatusCode() == 1) {
//                this.removeById(machineInfo.getId());
//            }
//        });
//    }
//
//    @Override
//    public void deleteMachineInfo(Long machineInfoId) {
//        MachineInfo machineInfo = this.getById(machineInfoId);
//        if (machineInfo.getStatusCode() == 1) {
//            this.removeById(machineInfoId);
//        }
//    }
//
//    private QueryWrapper<MachineInfo> getMachineInfoQueryWrapper(MachineInfoDto machineInfoDto) {
//        QueryWrapper<MachineInfo> queryWrapper = new QueryWrapper<>();
//        if (machineInfoDto.getStatus() != null && !machineInfoDto.getStatus().isEmpty()) {
//            queryWrapper.eq("status_code", EnumUtils.getEnumByMessage(machineInfoDto.getStatus(), MachineInfoStatus.class).getCode());
//        }
//        if (machineInfoDto.getName() != null && !machineInfoDto.getName().isEmpty()) {
//            queryWrapper.like("name", machineInfoDto.getName());
//        }
//        if (machineInfoDto.getTag() != null && !machineInfoDto.getTag().isEmpty()) {
//            queryWrapper.like("tag", machineInfoDto.getTag());
//        }
//        if (machineInfoDto.getHostIp() != null && !machineInfoDto.getHostIp().isEmpty()) {
//            queryWrapper.like("host_ip", machineInfoDto.getHostIp());
//        }
//        if (machineInfoDto.getDescription() != null && !machineInfoDto.getDescription().isEmpty()) {
//            queryWrapper.like("description", machineInfoDto.getDescription());
//        }
//        return queryWrapper.orderByDesc("create_date");
//    }
//
//
//    @Override
//    public boolean testConnection(Long id) {
//        //先查询机器是否存在，在判断机器可用性
//        MachineInfo machineInfo = machineInfoMapper.getById(id);
//        if (machineInfo==null){
//            throw new RuntimeException("机器不存在");
//        }
//        if (machineInfo.getStatusCode() == 0) {
//            throw new RuntimeException("机器不可用");
//        }
//        log.info("测试机器连接: {}", machineInfo.getHostIp());
//        connectionSession.setMachineInfo(machineInfo);
//        try{
//            connectionSession.connect();
//            return true;
//        } catch (Exception e) {
//            log.error("机器连接测试失败: {}", e.getMessage(), e);
//            return false;
//        }
//    }
//
//    @Override
//    public ConnectionStatus getConnectionStatus(String machineName) {
//        String sessionId = machineSessionMapping.get(machineName);
//        if (sessionId == null) {
//            return ConnectionStatus.DISCONNECTED;
//        }
//
//        ConnectionSession session = sessions.get(sessionId);
//        return session != null ? session.getStatus() : ConnectionStatus.DISCONNECTED;
//    }
//
//    @Override
//    public Map<String, ConnectionStatus> getAllConnectionStatus() {
//        Map<String, ConnectionStatus> result = new HashMap<>();
//
//        machineSessionMapping.forEach((machineName, sessionId) -> {
//            ConnectionSession session = sessions.get(sessionId);
//            result.put(machineName, session != null ? session.getStatus() : ConnectionStatus.DISCONNECTED);
//        });
//
//        return result;
//    }
//
//    @Override
//    public String connect(MachineInfo machineInfo) {
//        if (machineInfo.getStatus().getCode() == UN_ENABLE) {
//            throw new RuntimeException("机器不可用");
//        }
//        log.info("建立机器连接: {}", machineInfo.getHostIp());
//
//        // 检查是否已连接
//        String existingSessionId = machineSessionMapping.get(machineInfo.getName());
//        if (existingSessionId != null) {
//            ConnectionSession existingSession = sessions.get(existingSessionId);
//            if (existingSession != null && existingSession.getStatus() == ConnectionStatus.CONNECTED) {
//                log.info("机器已连接，返回现有会话: {}", machineInfo.getHostIp());
//                return existingSessionId;
//            }
//        }
//
//        try {
//            connectionSession.setMachineInfo(machineInfo);
//
//            connectionSession.connect();
//
//            // 生成会话ID
//            String sessionId = generateSessionId();
//
//            // 保存会话
//            sessions.put(sessionId, connectionSession);
//            machineSessionMapping.put(machineInfo.getName(), sessionId);
//
//            log.info("机器连接成功: {}, 会话ID: {}", machineInfo.getHostIp(), sessionId);
//            return sessionId;
//        } catch (Exception e) {
//            log.error("机器连接失败: {}", e.getMessage(), e);
//            throw new RuntimeException("机器连接失败: " + e.getMessage(), e);
//        }
//    }
//
//    @Override
//    public boolean disconnect(String sessionId) {
//        log.info("断开机器连接: {}", sessionId);
//
//        ConnectionSession session = sessions.get(sessionId);
//        if (session == null) {
//            log.warn("会话不存在: {}", sessionId);
//            return false;
//        }
//
//        try {
//            session.disconnect();
//
//            // 清理会话
//            sessions.remove(sessionId);
//            machineSessionMapping.entrySet().removeIf(entry -> entry.getValue().equals(sessionId));
//
//            log.info("机器连接已断开: {}", sessionId);
//            return true;
//        } catch (Exception e) {
//            log.error("断开连接失败: {}", e.getMessage(), e);
//            return false;
//        }
//    }
//
//    @Override
//    public String executeCommand(String sessionId, String command) {
//        log.info("执行命令: {}, 会话ID: {}", command, sessionId);
//
//        ConnectionSession session = sessions.get(sessionId);
//        if (session == null) {
//            throw new RuntimeException("会话不存在: " + sessionId);
//        }
//
//        if (session.getStatus() != ConnectionStatus.CONNECTED) {
//            throw new RuntimeException("会话未连接: " + sessionId);
//        }
//
//        try {
//            return session.executeCommand(command);
//        } catch (Exception e) {
//            log.error("命令执行失败: {}", e.getMessage(), e);
//            throw new RuntimeException("命令执行失败: " + e.getMessage(), e);
//        }
//    }
//
//    @Override
//    public boolean uploadFile(String sessionId, String localFilePath, String remoteFilePath) {
//        log.info("上传文件: {} -> {}, 会话ID: {}", localFilePath, remoteFilePath, sessionId);
//
//        ConnectionSession session = sessions.get(sessionId);
//        if (session == null) {
//            throw new RuntimeException("会话不存在: " + sessionId);
//        }
//
//        if (session.getStatus() != ConnectionStatus.CONNECTED) {
//            throw new RuntimeException("会话未连接: " + sessionId);
//        }
//
//        try {
//            return session.uploadFile(localFilePath, remoteFilePath);
//        } catch (Exception e) {
//            log.error("文件上传失败: {}", e.getMessage(), e);
//            throw new RuntimeException("文件上传失败: " + e.getMessage(), e);
//        }
//    }
//
//    @Override
//    public boolean downloadFile(String sessionId, String remoteFilePath, String localFilePath) {
//        log.info("下载文件: {} -> {}, 会话ID: {}", remoteFilePath, localFilePath, sessionId);
//
//        ConnectionSession session = sessions.get(sessionId);
//        if (session == null) {
//            throw new RuntimeException("会话不存在: " + sessionId);
//        }
//
//        if (session.getStatus() != ConnectionStatus.CONNECTED) {
//            throw new RuntimeException("会话未连接: " + sessionId);
//        }
//
//        try {
//            return session.downloadFile(remoteFilePath, localFilePath);
//        } catch (Exception e) {
//            log.error("文件下载失败: {}", e.getMessage(), e);
//            throw new RuntimeException("文件下载失败: " + e.getMessage(), e);
//        }
//    }
//
//
//    /**
//     * 生成会话ID
//     */
//    private String generateSessionId() {
//        return "session-" + sessionIdGenerator.incrementAndGet();
//    }
//}
