//package cd.casic.module.machine.service.impl;
//
//import cd.casic.module.machine.controller.vo.SecretKeyDto;
//import cd.casic.module.machine.dal.dataobject.MachineInfo;
//import cd.casic.module.machine.dal.dataobject.SecretKey;
//import cd.casic.module.machine.dal.mysql.SecretServiceMapper;
//import cd.casic.module.machine.service.MachineInfoService;
//import cn.hutool.core.io.resource.ResourceUtil;
//import cn.hutool.core.util.IdUtil;
//import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
//import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
//import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
//
//import cd.casic.module.machine.utils.AliYunOssClient;
//import cd.casic.module.machine.exception.ServiceException;
////import cd.casic.module.machine.service.MachineInfoService;
//import cd.casic.module.machine.service.SecretKeyService;
//import jakarta.annotation.Resource;
//import org.springframework.beans.BeanUtils;
//import org.springframework.stereotype.Service;
//
//import java.util.List;
//
//@Service
//public class SecretKeyServiceImpl extends ServiceImpl<SecretServiceMapper, SecretKey> implements SecretKeyService {
//
//    @Resource
//    private MachineInfoService machineInfoService;
//
//    @Resource
//    private AliYunOssClient aliYunOssClient;
//
//    @Resource
//    private SecretServiceMapper secretServiceMapper;
//
//
//
//
//    @Override
//    public boolean addSecretKey(SecretKeyDto secretKeyDto){
//        if (secretKeyDto.getPath()==null)
//        {
//            throw new ServiceException(ServiceException.MACHINE_PROXY_NULL,"密钥不能为空");
//        }
//
//        String ossPath = upLoadSecretKey(secretKeyDto.getPath());
//        if (ossPath == null){
//            throw new ServiceException(ServiceException.MACHINE_PROXY_NULL,"密钥上传失败");
//        }
//        secretKeyDto.setPath(ossPath);
//        SecretKey secretKey = new SecretKey();
//        BeanUtils.copyProperties(secretKeyDto,secretKey);
//        //todo检查密钥合法
//        return this.save(secretKey);
//
//
//    }
//    @Override
//    public boolean updateSecretKey(SecretKeyDto secretKeyDto) {
//
//        Long id = secretKeyDto.getId();
//        SecretKey secretKey = this.getById(id);
//        if (secretKey == null){
//            throw new ServiceException(ServiceException.MACHINE_PROXY_NULL,"密钥不存在");
//        }
//        if (!secretKey.getPath().equals(secretKeyDto.getPath())) {
//            //todo检查密钥合法
//            String ossPath = upLoadSecretKey(secretKeyDto.getPath());
//            BeanUtils.copyProperties(secretKeyDto,secretKey);
//            secretKey.setPath(ossPath);
//        }
//        else {
//            BeanUtils.copyProperties(secretKeyDto,secretKey);
//        }
//
//        return this.updateById(secretKey);
//
//
//    }
//
//    @Override
//    public void bindingMachine(Long secretKeyId, List<Long> machineIds) {
//        SecretKey secretKey = this.getById(secretKeyId);
//        if (secretKey==null){
//            throw new ServiceException(ServiceException.SECRETKEY_NULL,"密钥不存在");
//        }
//        List<MachineInfo> machineList = machineInfoService.listByIds(machineIds);
//        machineList.forEach(machine -> machine.setSecretKeyId(secretKeyId));
//        machineInfoService.updateBatchById(machineList);
//    }
//
//
//
//
//
//    @Override
//    public PageResult<SecretKey> listSecretKey(SecretKeyDto secretKeyDto) {
//        QueryWrapper<SecretKey> queryWrapper = new QueryWrapper<>();
//        if (secretKeyDto.getName() != null && !secretKeyDto.getName().isEmpty()){
//            queryWrapper.like("name", secretKeyDto.getName());
//        }
//        if (secretKeyDto.getDescription() != null && !secretKeyDto.getDescription().isEmpty()){
//            queryWrapper.like("description", secretKeyDto.getDescription());
//        }
//        Page<SecretKey> page = secretServiceMapper.selectPage(new Page<>(secretKeyDto.getPageIndex(), secretKeyDto.getPageSize()), queryWrapper);
//        return new  PageResult<>(
//            page.getCurrent(),
//            page.getSize(),
//            page.getTotal(),
//            page.getPages(),
//            page.getRecords()
//        );
//    }
//
//
//
//    @Override
//    public boolean deleteList(List<Long> secretKeyIds) {
//        List<SecretKey> secretKeys = this.listByIds(secretKeyIds);
//
//        for (SecretKey secretKey : secretKeys) {
//            if (secretKey.getPath() != null && !secretKey.getPath().isEmpty()){
//                try {
//                    //文件名
//                    //删除子目录文件，需要在前面加上根目录文件路径
//                    String fileName = secretKey.getPath().substring(secretKey.getPath().lastIndexOf("/") + 1);
//                    aliYunOssClient.delete(fileName);
//                } catch (Exception e) {
//                    throw new RuntimeException(e);
//                }
//            }
//        }
//
//
//        //todo是否删除已经绑定的机器
//        return secretServiceMapper.deleteBatchIds(secretKeyIds) > 0 ;
//    }
//
//
//    public String upLoadSecretKey(String localPath) {
//
//        //使用S3FileClient上传文件
//        aliYunOssClient.init();
//
//        //传输到指定文件，需要在path前面加上文件路径
//        String path = IdUtil.fastSimpleUUID() + ".txt";
//
//
//        //上传文件是从本地上传，这里传的是本地文件地址
//        byte[] content = ResourceUtil.readBytes(localPath);
//        String ossPath;
//        try {
//            ossPath = aliYunOssClient.upload(content, path, "txt");
//        }catch (Exception e) {
//            throw new RuntimeException(e+"上传文件失败");
//        }
//        return ossPath;
//    }
//}
