package cd.casic.module.machine.utils;

import io.micrometer.common.util.StringUtils;

import java.util.function.Consumer;

/**
 * 属性操作工具类
 */
public class PropertyUtils {

    /**
     * 如果不为空则设置值
     *
     * @param value  值
     * @param setter 具体set操作
     */
    public static void setIfNotBlank(String value, Consumer<String> setter) {
        if (StringUtils.isNotBlank(value)) {
            setter.accept(value);
        }
    }

    /**
     * 如果不为空则设置值
     *
     * @param value  值
     * @param setter 具体set操作
     */
    public static <T> void setIfNotNull(T value, Consumer<T> setter) {
        if (value != null) {
            setter.accept(value);
        }
    }
}
