package cd.casic.module.process.process.definition.dao;

import cd.casic.ci.commons.bean.process.definition.PipelineFollowQuery;
import cd.casic.framework.mybatis.core.mapper.BaseMapperX;
import cd.casic.module.process.pipeline.definition.entity.PipelineFollowEntity;
import cd.casic.module.process.process.definition.dataobject.PipelineFollowDo;
import org.apache.ibatis.annotations.Mapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;

import java.util.List;

/**
 * @author by mianbin
 * @Classname PipelineFollowDao
 * @Description TODO
 * @Date 2025/4/23 14:23
 */
@Mapper
public interface PipelineFollowDao extends BaseMapperX<PipelineFollowDo> {

    /**
     * 创建收藏
     * @param pipelineFollowEntity 收藏
     * @return 收藏id
     */
    public String createFollow(PipelineFollowEntity pipelineFollowEntity);

    /**
     * 删除收藏
     * @param followId 收藏id
     */
    public void deleteFollow(String followId);

    /**
     * 更新收藏
     * @param pipelineFollowEntity 更新信息
     */
    public void updateFollow(PipelineFollowEntity pipelineFollowEntity);

    /**
     * 查询单个收藏信息
     * @param followId 收藏id
     * @return 收藏信息
     */
    public PipelineFollowEntity findOneFollow(String followId);

    /**
     * 查询所有收藏
     * @return 收藏集合
     */
    public List<PipelineFollowEntity> findAllFollow();


    public List<PipelineFollowEntity> findAllFollowList(List<String> idList);

    /**
     * 查询用户是否收藏该流水线
     * @param userId 用户id
     * @param pipelineId 流水线id
     * @return 收藏信息
     */
    public List<PipelineFollowEntity> findOneUserFollowPipeline(String userId, String pipelineId);

    /**
     * 查询用户是藏的流水线
     * @param userId 用户id
     * @return 收藏信息
     */
    public List<PipelineFollowEntity> findUserFollowPipeline(String userId);


    public List<PipelineFollowEntity> findFollowQueryList(PipelineFollowQuery followQuery);
}
