package cd.casic.module.process.process.setting.impl;

import cd.casic.ci.commons.bean.process.setting.AuthHostGroupDetails;
import cd.casic.module.process.convert.setting.AuthHostGroupDetailsConvert;
import cd.casic.module.process.process.setting.AuthHostGroupDetailsService;
import cd.casic.module.process.process.setting.dao.AuthHostGroupDetailsDao;
import cd.casic.module.process.process.setting.dataobject.AuthHostGroupDetailsDo;
import jakarta.annotation.Resource;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class AuthHostGroupDetailsServiceImpl implements AuthHostGroupDetailsService {

    @Resource
    AuthHostGroupDetailsDao authHostGroupDetailsDao;

    @Override
    public Integer creatHostGroupDetails(AuthHostGroupDetails hostGroupDetails) {
        return authHostGroupDetailsDao.insert(AuthHostGroupDetailsConvert.INSTANCE.convertDo(hostGroupDetails));
    }

    @Override
    public void updateHostGroupDetails(AuthHostGroupDetails hostGroupDetails) {
        authHostGroupDetailsDao.updateById(AuthHostGroupDetailsConvert.INSTANCE.convertDo(hostGroupDetails));
    }

    @Override
    public void deleteHostGroupDetails(String groupDetailsId) {
        authHostGroupDetailsDao.deleteById(groupDetailsId);
    }

    @Override
    public AuthHostGroupDetails findOneHostGroupDetails(String groupDetailsId) {
        return AuthHostGroupDetailsConvert.INSTANCE.convert(authHostGroupDetailsDao.selectById(groupDetailsId));
    }

    @Override
    public List<AuthHostGroupDetails> findAllHostGroupDetails() {
        return AuthHostGroupDetailsConvert.INSTANCE.convertList(authHostGroupDetailsDao.selectList());
    }

    @Override
    public List<AuthHostGroupDetails> findHostGroupDetailsList(String groupId) {
        return AuthHostGroupDetailsConvert.INSTANCE.convertList(
                authHostGroupDetailsDao.selectList(AuthHostGroupDetailsDo::getGroupId, groupId));
    }
}
