package cd.casic.module.process.process.stage.dataobject;

import cd.casic.framework.mybatis.core.dataobject.BaseDO;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.*;
import lombok.experimental.Accessors;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * 流水线阶段实体
 */
@Data
@Builder
@Accessors(chain = true)
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@TableName(value = "pip_stage", autoResultMap = true)
public class StageDo extends BaseDO {

    @TableId
    private String stageId;

    //阶段名称
    private String stageName;

    //创建配置时间 TODO 和超类冲突
//    private String createTime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date());

    //流水线
    private String pipelineId;

    //主节点
    private String parentId;

    //阶段顺序
    private int stageSort;

    //是否为源码
    private String code;
}
