package cd.casic.module.process.service.support.deploy.dataobject;

import cd.casic.framework.mybatis.core.dataobject.BaseDO;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.*;
import lombok.experimental.Accessors;

@Data
@Builder
@Accessors(chain = true)
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@TableName(value = "pip_task_deploy", autoResultMap = true)
public class TaskDeployDo extends BaseDO {

    @TableId
    private String taskId;

    //认证类型
    private int authType;

    //文件地址
    private String localAddress;

    //部署地址
    private String deployAddress;

    //认证id
    private String authId;

    //部署命令
    private String deployOrder;

    //启动文件地址
    private String startAddress;

    //启动命令
    private String startOrder;

    private String dockerImage;

    private String rule;

    // 命名空间
    private String k8sNamespace;

    // 配置文件
    private String k8sJson;

    // 策略类型
    private String strategyType;

    // 策略数量
    private Integer strategyNumber;
}
