package cd.casic.module.process.task.build.dataobject;

import cd.casic.framework.mybatis.core.dataobject.BaseDO;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

/**
 * @ClassName TaskArtifactXpackServiceImpl
 * @Author hopeli
 * @Date 2025/5/2 19:23
 * @Version 1.0
 */



@Data
@Builder
@Accessors(chain = true)
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@TableName(value = "pip_task_build", autoResultMap = true)
public class TaskBuildDo extends BaseDO {

    @TableId
    private String taskId;

    //地址
    private String buildAddress;

    //分支
    private String buildOrder;

    private String productRule;

    private String dockerName;

    private String dockerVersion;

    private String dockerFile;

    private String dockerOrder;

    // jdk版本
    private String toolJdk;

    // maven版本
    private String toolMaven;

    // npm版本
    private String toolNodejs;


}
