package cd.casic.module.process.task.code.dao;

/**
 * @ClassName TaskArtifactXpackServiceImpl
 * @Author hopeli
 * @Date 2025/5/2 20:25
 * @Version 1.0
 */

import cd.casic.module.process.task.code.jpa.JpaTemplate;
import cd.casic.module.process.task.code.dataobject.TaskCodeDo;
import jakarta.annotation.Resource;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public class TaskCodeDao {

    @Resource
    JpaTemplate jpaTemplate;

    /**
     * 创建
     * @param taskCodeDo code信息
     * @return codeId
     */
    public String createCode(TaskCodeDo taskCodeDo){
      return jpaTemplate.save(taskCodeDo,String.class);
    }

    /**
     * 删除code
     * @param codeId codeId
     */
    public void deleteCode(String codeId){
        jpaTemplate.delete(TaskCodeDo.class,codeId);
    }

    /**
     * 更新code
     * @param taskCodeDo 更新信息
     */
    public void updateCode(TaskCodeDo taskCodeDo){
        jpaTemplate.update(taskCodeDo);
    }

    /**
     * 查询单个code信息
     * @param codeId codeId
     * @return code信息
     */
    public TaskCodeDo findOneCode(String codeId){
       return jpaTemplate.findOne(TaskCodeDo.class,codeId);
    }

    /**
     * 查询所有code信息
     * @return code信息集合
     */
    public List<TaskCodeDo> findAllCode(){
        return jpaTemplate.findAll(TaskCodeDo.class);
    }

    public List<TaskCodeDo> findAllCodeList(List<String> idList){
        return jpaTemplate.findList(TaskCodeDo.class,idList);
    }


}
